From 6212bfe0ddad80609021593ed11ccfbcbf0c872a Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 22 2017 18:23:02 +0000
Subject: [PATCH 887/1001] Handle error cases better in the SSE server


---

diff --git a/hubs/backend/sse_server.py b/hubs/backend/sse_server.py
index 781ddb2..7bcd7c7 100644
--- a/hubs/backend/sse_server.py
+++ b/hubs/backend/sse_server.py
@@ -9,7 +9,7 @@ import txredisapi as redis
 
 from twisted.application import service
 from twisted.web import server, resource
-from twisted.internet import reactor, defer
+from twisted.internet import reactor, defer, task
 from twisted.logger import (
     Logger, globalLogBeginner, ILogObserver, formatEvent)
 from zope.interface import provider
@@ -102,6 +102,7 @@ class Subscribe(resource.Resource):
             self.subscribers[target] = []  # first request to this target.
         log.debug("New subscriber: {req}", req=request)
         self.subscribers[target].append(request)
+        self._send_event(request, "connected", "null")
         log.debug("There is now {count} subscribers to {target}.",
                   target=target, count=len(self.subscribers[target]))
 
@@ -116,11 +117,25 @@ class Subscribe(resource.Resource):
         log.debug("Broadcasting to {num} requests.",
                   num=len(target_subscribers))
         for request in target_subscribers:
-            if event:
-                request.write("event: {}\r\n".format(event).encode("utf-8"))
-            request.write("data: {}\r\n".format(data).encode("utf-8"))
-            # The last CRLF is required to dispatch the event to the client.
-            request.write(b"\r\n")
+            self._send_event(request, event, data)
+
+    def keepalive(self):
+        all_subscribers = []
+        for subs in self.subscribers.values():
+            all_subscribers.extend(subs)
+        if not all_subscribers:
+            return
+        log.debug("Broadcasting a ping to {num} requests.",
+                  num=len(all_subscribers))
+        for request in all_subscribers:
+            self._send_event(request, "ping", "null")
+
+    def _send_event(self, request, event, data):
+        if event:
+            request.write("event: {}\r\n".format(event).encode("utf-8"))
+        request.write("data: {}\r\n".format(data).encode("utf-8"))
+        # The last CRLF is required to dispatch the event to the client.
+        request.write(b"\r\n")
 
     def request_closed(self, err, request, target):
         log.debug("Removing subscriber {subscriber} from {target}.",
@@ -181,12 +196,18 @@ def main():
         print(formatEvent(event))
     globalLogBeginner.beginLoggingTo(
         [printingObserver], redirectStandardIO=False)
+    # Web service
     sub = Subscribe()
     site = server.Site(sub)
     port = int(hubs.app.app.config.get("SSE_URL", {}).get("port", 8080))
     reactor.listenTCP(port, site)
+    # Redis client
     redisclient = RedisClientService(sub)
     redisclient.startService()
+    # Keepalive ping
+    keepalive = task.LoopingCall(sub.keepalive)
+    keepalive.start(30)
+    # Start the reactor
     reactor.run()
 
 
diff --git a/hubs/backend/sse_server.tac b/hubs/backend/sse_server.tac
index 57dc41f..1ea980f 100644
--- a/hubs/backend/sse_server.tac
+++ b/hubs/backend/sse_server.tac
@@ -13,7 +13,7 @@ which twistd will look for
 from __future__ import unicode_literals
 
 from twisted.application import service, internet
-from twisted.internet import reactor
+from twisted.internet import reactor, task
 from twisted.web import server
 
 import hubs.app
@@ -37,3 +37,7 @@ web_service.setServiceParent(application)
 # Redis client
 redis_service = RedisClientService(broadcaster)
 redis_service.setServiceParent(application)
+
+# Keepalive ping
+keepalive = task.LoopingCall(broadcaster.keepalive)
+keepalive.start(30)
diff --git a/hubs/static/client/app/components/feed/ItemsGetter.jsx b/hubs/static/client/app/components/feed/ItemsGetter.jsx
index dcfe7ca..ca6397d 100644
--- a/hubs/static/client/app/components/feed/ItemsGetter.jsx
+++ b/hubs/static/client/app/components/feed/ItemsGetter.jsx
@@ -14,6 +14,7 @@ export default class ItemsGetter extends React.Component {
     this.tearDownSSESource = this.tearDownSSESource.bind(this);
     this.handleSSEEvent = this.handleSSEEvent.bind(this);
     this.handleSSEEventError = this.handleSSEEventError.bind(this);
+    this.handleSSEEventOpen = this.handleSSEEventOpen.bind(this);
     this.loadFromServer = this.loadFromServer.bind(this);
   }
 
@@ -42,6 +43,7 @@ export default class ItemsGetter extends React.Component {
       return;
     }
 
+    this.sseSource.addEventListener('open', this.handleSSEEventOpen);
     this.sseSource.addEventListener('error', this.handleSSEEventError);
     this.sseSource.addEventListener(
       this.props.sse.eventName, this.handleSSEEvent);
@@ -65,12 +67,24 @@ export default class ItemsGetter extends React.Component {
     }
   }
 
+  handleSSEEventOpen(e) {
+    this.setState({sseError: false});
+  }
+
   handleSSEEventError(e) {
     console.log(e);
-    this.setState({
-      sseError: ("Cannot auto-update the feed, you will have to refresh "
-                +"the page manually to see new elements.")
-    });
+    if (this.sseSource.readyState === 2) {
+      // Connection closed.
+      this.setState({
+        sseError: ("Cannot auto-update the feed, you will have to refresh "
+                  +"the page manually to see new elements.")
+      });
+    } else if (this.sseSource.readyState === 0) {
+      // Reconnecting
+      this.setState({
+        sseError: "Reconnecting to the auto-update source...",
+      });
+    }
   }
 
   loadFromServer() {

